<?php
  
  include "misc.php";
  include "zival.php";

  function readline($sock) {
    static $buffer = "";
    while (strpos($buffer, "\n") === FALSE) {
      $rcv = socket_read($sock, 130);
      if ($rcv === FALSE) exit(0);
      $buffer .= $rcv;
    }
    $r = explode("\n", $buffer, 2);
    $buffer = $r[1];
    return rtrim($r[0]);
  }

  function connect($hostname) {
    $addr = gethostbyname($hostname);
    $sock = socket_create(AF_INET, SOCK_STREAM, 0);
    if ($sock < 0) return -1;
    
    $ret = socket_connect($sock, $addr, 1174);
    if ($ret < 0) return -1;
    
    $srv = readline($sock);
    echo $srv . "\n";
    
    if ($GLOBALS['Tip'] == 1) {
      $tip = "MACKA";
    } else {
      $tip = "MIS";
    }
    
    $cmd = "AVE " . $tip . " " . $GLOBALS['Ime'] . "\n";
    socket_write($sock, $cmd);
    
    $resp = readline($sock);
    if ($resp != "PRIJAVA USPESNA") return -1;
    
    return $sock;
  }

  function event_loop($sock) {
    while (true) {
      $cmda = explode(" ", readline($sock));
      
      if ($cmda[0] == "ADIJO") return;
      if ($cmda[0] == "KONEC_IGRE") continue;
      if ($cmda[0] != "ZBUDI_SE") {
        echo "Napaka pri komunikaciji s streznikom.\n";
        return;
      }
      
      $Z = new Zival;
      $ZacetnaSmer = 0.0;
      $Z->ZbudiSe(array('X' => $cmda[1], 'Y' => $cmda[2]), array('X' => $cmda[3], 'Y' => $cmda[4]), $ZacetnaSmer);
      socket_write($sock, "BUDNA " . $ZacetnaSmer . "\n");
      
      while (true) {
        $cmda = explode(" ", readline($sock));
        
        if ($cmda[0] == "ADIJO") return;
        else if ($cmda[0] == "KONEC_IGRE") {
          $Z->KonecIgre($cmda[1]);
          break;
        } else if ($cmda[0] == "QV") {
          $SpremembaSmeri = 0.0;
          $SpremembaHitrosti = 0.0;
          $Z->KamGres(array('X' => $cmda[1], 'Y' => $cmda[2], 'D' => $cmda[3], 'V' => $cmda[4]),
            array('X' => $cmda[5], 'Y' => $cmda[6], 'D' => $cmda[7], 'V' => $cmda[8]), $SpremembaSmeri, $SpremembaHitrosti);
          socket_write($sock, "QVR " . $SpremembaSmeri . " " . $SpremembaHitrosti . "\n");
        }
      }
    }
  }

  // ---- main ----

  set_time_limit(0); 

  if ($argc < 2) {
    $hostname = "localhost";
  } else {
    $hostname = $argv[1];
  }

  $sock = connect($hostname);
  if ($sock == -1) {
    echo "Povezava s streznikom ni uspela.\n";
    exit(-1);
  }
  event_loop($sock);

?>
